import 'package:contextdart/contextdart.dart';
import 'package:logr/logr.dart';
import 'package:logr/stdlogr.dart';
import 'package:test/test.dart';

main() {
  var log = Logger(StdLogSink("logr"));

  test("log", () {
    log.info("info");
    log.v(0).info("v(0).info");
    log.v(1).info("v(1).info");
    log.error(Exception("error"), "error");
    log.withName("testing").info("with prefix");
  });

  test("sub actions", () {
    var ctx = Context.withValue(Context.background(), log);
    _someAction(ctx);
  });

  test("tracing", () {
    var ctx = Context.withValue(Context.background(), log);

    var ret = Logger.span(ctx, "action", (ctx) {
      Logger.fromContext(ctx)?.info("tracing action");

      return Logger.span(ctx, "sub action", (ctx) {
        Logger.fromContext(ctx)?.info("tracing action");
        return 1;
      });
    });

    expect(ret, 1);
  });
}

_someAction(Context ctx) {
  var log = Logger.fromContext(ctx)?.withName("someAction");
  log?.info("info");

  try {
    _throw();
  } catch (e, stackTrace) {
    log?.error(e as Exception, "do failed", stackTrace: stackTrace);
  }
}

_throw() {
  throw Exception("ops!");
}
